<?php
/**
* Memo.class.php
*
*
*
*
* @author	jens.schmelzer@fh-jena.de
* @version	$Id:  $
*/

// +---------------------------------------------------------------------------+
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or any later version.
// +---------------------------------------------------------------------------+
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
// +---------------------------------------------------------------------------+

require_once 'lib/visual.inc.php';

class Memo {
	var $db;
	var $title;
	var $ok = false;
	var $content = '';
	var $kid;

	function Memo($x = true){
		if ($x && !$this->check()) return;
		if (!isset($_SESSION['plugin_memo_status'])) $_SESSION['plugin_memo_status'] = 'close';
		$this->title = $this->getTitle();
		$this->db = DBManager::get();
		$pp = $this->db->prepare('SELECT * FROM plugin_memo WHERE user_id = ? ORDER BY sort LIMIT 1;');
		$pp->execute(array($GLOBALS['user']->id));
		$row = $pp->fetch();
		if (count($row)) {
			$name = $row['name'];
			$this->content = $row['content'];
			$this->kid = $row['memo_id'];
		} else {
			$name = $this->title;
			$this->content = _("Keine Notizen vorhanden :-)");
			$this->kid = md5(uniqid("blablubburegds4"));
			$pp = $this->db->prepare('INSERT INTO `plugin_memo` (`memo_id`, `user_id`, `name`, `content`, `mkdate`, `chdate`, `sort`) VALUES ( ?,  ?, ?, ?, ?, ?, 1);');
			$pp->execute(array($this->kid, $GLOBALS['user']->id, $name, $this->content, time(), time()));
		}

	}

	function check(){
		if (!$GLOBALS['auth']->auth['jscript']) return false;
		if (!$GLOBALS['perm']->have_perm('autor')) return false;
		$this->ok = true;
		return true;
	}

	function updateNote(){
		if (!$this->ok) return;
		if (array_key_exists('value', $_POST)) {
			$value = utf8_decode($_POST['value']);
			if (get_magic_quotes_gpc()) $value = stripslashes($value);
			if ($this->content != $value) {
				$pp = $this->db->prepare('UPDATE plugin_memo SET content=?, chdate=? WHERE memo_id=? AND user_id=?;');
				$pp->execute(array($value, time(), $this->kid, $GLOBALS['user']->id));
			}
			if (!preg_match('/\S/' ,$value)) {
				echo _("[bearbeiten]");
				return;
			}
			echo formatReady($value);
			return;
		}
		echo 'Fehler beim speichern!';
	}

	function getNoteForForm(){
		if (!$this->ok) return;
		return utf8_encode($this->content);
	}

	function getNote(){
		if (!$this->ok) return;
		$_SESSION['plugin_memo_status'] = 'open';
		if (!preg_match('/\S/' ,$this->content)) return _("[bearbeiten]");
		return formatReady($this->content);
	}

	function getTitle(){
		return _("Notizen");
	}

	function closeStatus(){
		if (!$this->ok) return;
		$_SESSION['plugin_memo_status'] = 'close';
	}

	function savePos(){
		if (!$this->ok) return;
		$xmax = (array_key_exists('memo_xmax', $_REQUEST))? intval($_REQUEST['memo_xmax']) : $GLOBALS['auth']->auth['xres'];
		if (array_key_exists('memo_xpos', $_REQUEST)) {
			$x = intval($_REQUEST['memo_xpos']);
			if ($x < 1) $x = 1;
			if ($x > ($xmax - 300 )) $x = $xmax - 300;
			$_SESSION['plugin_memo_xpos'] = $x;
		}
	}

	function writeForm($path){
	$name = _("Memo");
	$notizen = self::getTitle();
	$ausblenden = _("ausblenden");
	$klicken = _("Zum Bearbeiten hier klicken!");
	$verschieben = _("verschieben");
	$assets = $GLOBALS['ASSETS_URL'] . 'images';
	if (isset($_SESSION['plugin_memo_status']) && $_SESSION['plugin_memo_status'] == 'open') {
		$java = 'PluginMemoOpen();';
	} else {
		$java = '';
	}
	if (isset($_SESSION['plugin_memo_xpos']) && $_SESSION['plugin_memo_xpos'] > 0) {
		$xpos = 'right:'.intval($_SESSION['plugin_memo_xpos']).'px';
	} else {
		$xpos = 'right:20px';
	}
	$out = <<<ENDHTML
<div id="PluginMemo" style="position:absolute;display:none;top:120px;$xpos;width:300px;z-index:999;opacity:0.95;"><div style="background-color:#ffd;border:1px solid yellow;padding:30px 10px 10px 10px;text-align:left;"><div id="PluginMemo_move" style="position:absolute;width:99%;top:2px;left:2px;background-image: url('$path/img/memobg.gif');font-weight:bold;font-size:smaller;color:#fff;cursor:move;" title="$verschieben">&nbsp;$notizen</div><div style="position:absolute;top:2px;left:280px;width:17px;z-index:1000;cursor:pointer;" title="$ausblenden" onclick="PluginMemoClose();"><img src="$assets/x_transparent.gif" alt="$ausblenden" /></div><div id="PluginMemo_txt" style="position:static;background-color:#ffd;font-size:smaller;">&nbsp;</div></div></div>
<div style="display:none;">
	<script type="text/javascript">
	// <![CDATA[
	function PluginMemoClose(){
		new Ajax.Request("$path/ajaxMemoServer.php?ajax_cmd=PluginMemo&ajax_cmd2=close");
		Effect.Fade('PluginMemo', {duration: 0.3});
	}

	function PluginMemoOpen(){
			new Ajax.Request("$path/ajaxMemoServer.php?ajax_cmd=PluginMemo", {
				onSuccess: function(transport){
					$("PluginMemo_txt").update(transport.responseText);
					Effect.Appear("PluginMemo",{ duration: 0.3, to: 0.9});
				}
			});
	}

	function PluginMemo () {
		if ($("PluginMemo").visible()) {
			new Ajax.Request("$path/ajaxMemoServer.php?ajax_cmd=PluginMemo&ajax_cmd2=close");
			Effect.SlideUp("PluginMemo", {duration: 0.3});
		} else {
			new Ajax.Request("$path/ajaxMemoServer.php?ajax_cmd=PluginMemo", {
				onSuccess: function(transport){
					$("PluginMemo_txt").update(transport.responseText);
					Effect.SlideDown("PluginMemo",{ duration: 0.3,
						afterFinish: function(){
							Effect.Fade("PluginMemo", {to: 0.95 });	// for IE
							new Effect.ScrollTo("PluginMemo", {offset:-120});
						}
					});
					}
				});
		}
	}

	new Ajax.InPlaceEditor(\$('PluginMemo_txt'), '$path/ajaxMemoServer.php?ajax_cmd=PluginMemo&ajax_cmd2=update', { rows:8, cols:28, okButton:false, submitOnBlur:true, cancelLink:false,  clickToEditText: '$klicken', highlightendcolor:'#ffd', loadTextURL: '$path/ajaxMemoServer.php?ajax_cmd=PluginMemo&ajax_cmd2=form'});
	new Draggable('PluginMemo',{gohsting: true, scroll:window, handle:'PluginMemo_move',
		onEnd: function(){
			var a = Position.cumulativeOffset(\$('PluginMemo')).first();
			var b = Position.offsetParent(\$('PluginMemo')).getWidth();
			var c = b - a - 300;
			// \$("PluginMemo_txt").update(c);
			new Ajax.Request("$path/ajaxMemoServer.php?ajax_cmd=PluginMemo&ajax_cmd2=savePos&memo_xpos=" + c + "&memo_xmax=" + b);
		}
	});
	document.observe('dom:loaded', function()
	{
		var e = \$\$("#barTopMenu li").last();
		var html = '<li><div style="font-size: 12px; z-index: 2; line-height: 90%; padding-bottom: 3px;"><a href="javascript:PluginMemo();"><img  alt="$name" title="$name"  src="$path/img/memo.gif" border="0"><br/>$name</a></div></li>';
		new Insertion.After(\$(e), html);
		$java
	});
	// ]]>
	</script>
</div>
ENDHTML;
	echo $out;
	}


	function writeForm2($path, $link){
		$notizen = $this->getTitle();
		$assets = $GLOBALS['ASSETS_URL'] . 'images';
		if ($_REQUEST['memocmd'] == 'edit') {
			$note= '<textarea cols="28" rows="8" name="memodaten">'. htmlReady($this->content). '</textarea>';
			$cmd = 'save';
			$btxt = _("speichern");
		} else {
			if ($_REQUEST['memocmd'] == 'save' && array_key_exists('memodaten', $_POST)) {
				$value = $_POST['memodaten'];
				if (get_magic_quotes_gpc()) $value = stripslashes($value);
				if ($this->content != $value) {
					$pp = $this->db->prepare('UPDATE plugin_memo SET content=?, chdate=? WHERE memo_id=? AND user_id=?;');
					$pp->execute(array($value, time(), $this->kid, $GLOBALS['user']->id ));
				}
				$note = formatReady($value);
			} else {
				$note = formatReady($this->content);
			}
			$cmd = 'edit';
			$btxt = _("bearbeiten");
		}
		$out = <<<ENDHTML
<div id="PluginMemo" style="width:300px;margin-left:auto;margin-right:auto;"><form action="$link&memocmd=$cmd" method="post" style="display:inline;"><div style="background-color:#ffd;border:1px solid yellow;text-align:left;"><div id="PluginMemo_move" style="position:relative;width:99%;top:2px;left:2px;background-image: url('$path/img/memobg.gif');font-weight:bold;font-size:smaller;color:#fff;">&nbsp;$notizen</div><div id="PluginMemo_txt" style="background-color:#ffd;font-size:smaller;padding:10px;">$note
<div style="text-align:center;"><input type="submit" value="$btxt"></div></div></div>
</form></div>
ENDHTML;
		echo $out;
	}
}

?>
